package com.mx.cneeds.server.user.web;

import com.mx.cneeds.common.dto.RoleDto;
import com.mx.cneeds.common.pager.PageUtils;
import com.mx.cneeds.common.result.R;
import com.mx.cneeds.common.validator.ValidatorUtils;
import com.mx.cneeds.server.entity.SysDeptEntity;
import com.mx.cneeds.server.entity.SysRoleEntity;
import com.mx.cneeds.server.user.service.SysDeptService;
import com.mx.cneeds.server.user.service.SysRoleService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

//import org.apache.shiro.authz.annotation.RequiresPermissions;


/**
 * 角色表
 *
 * @author Mark
 * @email sunlightcs@gmail.com
 * @date 2020-01-09 15:09:01
 */
@RestController
@RequestMapping("sys/role")
public class SysRoleController {
    @Autowired
    private SysRoleService sysRoleService;

    @Autowired
    private SysDeptService sysDeptService;
    /**
     * 列表
     */
    @RequestMapping("/list")
//    @RequiresPermissions("sys:sysrole:list")
    public PageUtils list(@RequestParam Map<String, Object> params){
        PageUtils page = sysRoleService.queryPage(params);

        List<Long> list = new ArrayList<>();

        page.getList().forEach(e -> {
            SysRoleEntity entity = (SysRoleEntity) e;
            list.add(entity.getDeptId());
        });

        List<SysDeptEntity> sysDeptEntityList = sysDeptService.queryDeptIdsBydeptName(list);

        List<RoleDto> roleDtos = new ArrayList<>();
        page.getList().forEach(e -> {
            SysRoleEntity entity = (SysRoleEntity) e;
            for(SysDeptEntity deptEntity :sysDeptEntityList) {
                if (deptEntity.getDeptId().equals(entity.getDeptId())){
                    RoleDto roleDto = new RoleDto();
                    BeanUtils.copyProperties(entity,roleDto);
                    roleDto.setDeptName(deptEntity.getName());
                    roleDtos.add(roleDto);
                }
            }
        });
        page.setList(roleDtos);
        return page;
    }


    /**
     * 信息
     */
    @RequestMapping("/info/{roleId}")
//    @RequiresPermissions("sys:sysrole:info")
    public R info(@PathVariable("roleId") Long roleId){
        SysRoleEntity sysRole = sysRoleService.getById(roleId);

        return R.ok().put("sysRole", sysRole);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
//    @RequiresPermissions("sys:sysrole:save")
    public R save(@RequestBody SysRoleEntity sysRole){
        sysRoleService.save(sysRole);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
//    @RequiresPermissions("sys:sysrole:update")
    public R update(@RequestBody SysRoleEntity sysRole){
        ValidatorUtils.validateEntity(sysRole);
        sysRoleService.updateById(sysRole);
        
        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
//    @RequiresPermissions("sys:sysrole:delete")
    public R delete(@RequestBody Long[] roleIds){
        sysRoleService.removeByIds(Arrays.asList(roleIds));

        return R.ok();
    }

}
